import React from 'react';
import { AnyReducer, ContextProvider, State } from './createContext';
import { UseGlobalState, UseGlobalDispatch } from './hook';
export declare type UseReducerContextSource = {
    [displayName: string]: {
        reducer: AnyReducer;
        initialState: any;
        initializer?: any;
    };
};
/**
 * *useReducer* to create multiple contexts.
 * The created contexts are split into a state and a dispatch,
 * respectively, to prevent unnecessary rendering.
 */
export declare const createUseReducerContext: <T extends UseReducerContextSource>(contextSource: T) => [UseGlobalState<T>, UseGlobalDispatch<T>, React.FC<ContextProvider<State<T>>>];
