/// <reference types="react" />
import { UseReducerContextSource } from './createUseReducerContext';
import { ReducerState, ReducerDispatch, State, Dispatch } from './createContext';
import { Subscription } from '../core/subscription';
export declare type UseGlobalState<T extends UseReducerContextSource> = {
    (): {
        [P in keyof T]: ReducerState<T[P]['reducer']>;
    };
    <SelectedState>(selector: (state: {
        [P in keyof T]: ReducerState<T[P]['reducer']>;
    }) => SelectedState): SelectedState;
};
export declare type UseGlobalDispatch<T extends UseReducerContextSource> = {
    (): {
        [P in keyof T]: ReducerDispatch<T[P]['reducer']>;
    };
    <SelectedState>(selector: (state: {
        [P in keyof T]: ReducerDispatch<T[P]['reducer']>;
    }) => SelectedState): SelectedState;
};
export declare const createStore: <T extends UseReducerContextSource>(stateContext: import("react").Context<State<T>>, stateSubscription: Subscription<State<T>>, dispatchContext: import("react").Context<Dispatch<T>>, dispatchSubscription: Subscription<Dispatch<T>>) => {
    useGlobalState: {
        (): State<T>;
        <SelectedState>(selector: (state: State<T>) => SelectedState): SelectedState;
    };
    useGlobalDispatch: {
        (): Dispatch<T>;
        <SelectedState_1>(selector: (state: Dispatch<T>) => SelectedState_1): SelectedState_1;
    };
};
