import React from 'react';
import { UseStateContextSource } from './createUseStateContext';
import { UseGlobalDispatch } from './hook';
import { Store } from '../core/store';
export declare type ContextProvider<T extends Record<string, unknown>> = {
    children: React.ReactNode;
    store?: Store<T>;
};
export declare type UseStateContext<T extends UseStateContextSource> = {
    [P in keyof T]: {
        state: React.Context<T[P]>;
        dispatch: React.Context<React.Dispatch<React.SetStateAction<T[P]>>>;
    };
};
export declare type Dispatch<T extends UseStateContextSource> = {
    [P in keyof T]: React.Dispatch<React.SetStateAction<T[P]>>;
};
export declare const createContext: <T extends UseStateContextSource>(contextSource: T) => {
    useGlobalState: import("./hook").UseGlobalState<T>;
    useGlobalDispatch: UseGlobalDispatch<T>;
    contextProvider: React.FC<ContextProvider<T>>;
};
