import React from 'react';
import { ContextProvider } from './createContext';
import { UseGlobalState, UseGlobalDispatch } from './hook';
export declare type UseStateContextSource = {
    [displayName: string]: any;
};
/**
 * *useState* to create multiple contexts.
 * The created contexts are split into a state and a dispatch,
 * respectively, to prevent unnecessary rendering.
 */
export declare const createUseStateContext: <T extends UseStateContextSource>(contextSource: T) => [UseGlobalState<T>, UseGlobalDispatch<T>, React.FC<ContextProvider<T>>];
