import React from 'react';
import { UseStateContextSource } from './createUseStateContext';
import { Dispatch } from './createContext';
import { Subscription } from '../core/subscription';
export declare type UseGlobalState<T extends UseStateContextSource> = {
    (): T;
    <SelectedState>(selector: (state: T) => SelectedState): SelectedState;
};
export declare type UseGlobalDispatch<T extends UseStateContextSource> = {
    (): {
        [P in keyof T]: React.Dispatch<React.SetStateAction<T[P]>>;
    };
    <SelectedState>(selector: (state: {
        [P in keyof T]: React.Dispatch<React.SetStateAction<T[P]>>;
    }) => SelectedState): SelectedState;
};
export declare const createStore: <T extends UseStateContextSource>(stateContext: React.Context<T>, stateSubscription: Subscription<T>, dispatchContext: React.Context<Dispatch<T>>, dispatchSubscription: Subscription<Dispatch<T>>) => {
    useGlobalState: UseGlobalState<T>;
    useGlobalDispatch: UseGlobalDispatch<T>;
};
